#!/bin/bash
# change gcc and g++.
# 
# Usage: chgcc -v {296|323}
#
# Copyright 2004 MIRACLE LINUX CORPORATION
#
# History:
#   21 Apr 2004 first version
#

gcc_ver="unknown"
gplus_ver="unknown"
usage="USAGE: $0 -v {296|323}"

if [ $# != 2 ]; then
	echo $usage
	exit 1
fi

uid=`/usr/bin/id|awk -F\( '{print $2}'|awk -F\) '{print $1}'`
if [ $uid != "root" ];then
	echo "You must be logged in as root."
	exit 1
fi

while getopts ":v:" opt
do
	case $opt in
	v) 
        targetver=$OPTARG
		if [ $targetver != "296" -a $targetver != "323" ]; then
			echo $usage
			exit 1
		fi
		;;
	*)
		echo $usage
		exit 1
	esac
done

ch296()
{
	mv /usr/bin/gcc /usr/bin/gcc323
	mv /usr/bin/g++ /usr/bin/g++323
	ln -s /usr/bin/gcc296 /usr/bin/gcc
	ln -s /usr/bin/g++296 /usr/bin/g++

	echo ""
	echo "The gcc and g++ were changed to each 2.96."
	echo "When you want to return it, run \"$0 -v 323\" command."
	echo ""
	echo "mv /usr/bin/gcc /usr/bin/gcc323"
	echo "mv /usr/bin/g++ /usr/bin/g++323"
	echo "ln -s /usr/bin/gcc296 /usr/bin/gcc"
	echo "ln -s /usr/bin/g++296 /usr/bin/g++"
}

ch323()
{
	if [ -L /usr/bin/gcc ] && [ -L /usr/bin/g++ ]; then
		rm /usr/bin/gcc
		rm /usr/bin/g++
	else
		echo "ERROR: logic error."
		exit 1
	fi
	mv /usr/bin/gcc323 /usr/bin/gcc
	mv /usr/bin/g++323 /usr/bin/g++

	echo ""
	echo "The gcc and g++ were changed to each 3.2.3(original version)."
	echo "When you want to change 2.96, run \"$0 -v 296\" command."
	echo ""
	echo "rm /usr/bin/gcc"
	echo "rm /usr/bin/g++"
	echo "mv /usr/bin/gcc323 /usr/bin/gcc"
	echo "mv /usr/bin/g++323 /usr/bin/g++"
}

if [ ! -f /usr/bin/gcc ]; then
	echo "/usr/bin/gcc does not exists."
	exit 1
fi

gcc_ver_tmp=`/usr/bin/gcc --version`

echo $gcc_ver_tmp | grep "2.96" >/dev/null
if [ $? = 0 ]; then
	gcc_ver="2.96"
fi
echo $gcc_ver_tmp | grep "3.2.3" >/dev/null
if [ $? = 0 ]; then
	gcc_ver="3.2.3"
fi

if [ ! -f /usr/bin/g++ ]; then
	echo "/usr/bin/g++ does not exists."
	exit 1
fi

gplus_ver_tmp=`/usr/bin/g++ --version`

echo $gplus_ver_tmp | grep "2.96" >/dev/null
if [ $? = 0 ]; then
	gplus_ver="2.96"
fi
echo $gplus_ver_tmp | grep "3.2.3" >/dev/null
if [ $? = 0 ]; then
	gplus_ver="3.2.3"
fi

echo "The current gcc version is $gcc_ver."
echo "The current g++ version is $gplus_ver."

if [ $gcc_ver = "unknown" ] || [ $gplus_ver = "unknown" ]; then
	echo "Discovered unknown version."
	exit 1
fi
if [ $gcc_ver != $gplus_ver ]; then
	echo "Mismatch version gcc and g++."
	exit 1
fi


if [ $targetver = "296" ] && [ $gcc_ver = "3.2.3" ]; then
	ch296
elif [ $targetver = "323" ] && [ $gcc_ver = "2.96" ]; then
	ch323
else
	echo "It doesn't need to change it."
fi

exit 0
